package com.lincolnpeak.i2b2.restlet.pmnresources;

import org.restlet.representation.Representation;
import org.restlet.resource.Get;

import com.lincolnpeak.i2b2.restlet.pmnresources.exceptions.CannotBuildRestResponse;
import com.lincolnpeak.i2b2.restlet.pmnresources.responses.StatusResponse;
import com.lincolnpeak.i2b2.restlet.pmnresources.responses.StatusResult;

public class GetStatus extends PMNResource 
{
	@Get
	public Representation Status() throws CannotBuildRestResponse 
	{
		String requestId = (String) getRequestAttributes().get("requestId");
		I2B2Request i2b2Request = I2B2Requests.getInstance().get(requestId);
		
		try 
		{
			StatusResponse status = new StatusResponse();
			StatusResult result = new StatusResult();
			
			result.setCode(i2b2Request.getStatus());
			result.setMessage(i2b2Request.getStatusMessage());
			status.setStatus(result);
			
			return buildRestResponse(status);

//			DomRepresentation domRep = new DomRepresentation();
//
//			JAXBContext context = JAXBContext.newInstance(StatusResponse.class);
//			Marshaller marshaller = context.createMarshaller();
//			marshaller.setProperty(Marshaller.JAXB_FORMATTED_OUTPUT, true);
//			DocumentBuilder docBuilder = DocumentBuilderFactory.newInstance().newDocumentBuilder();
//			Document document = docBuilder.newDocument();
//			marshaller.marshal(status, document);
//			domRep.setDocument(document);
//			return domRep;
		} 
		catch(CannotBuildRestResponse e)
		{
			i2b2Request.setStatus(StatusCode.Error);
			i2b2Request.setStatusMessage(e.getMessage());
			throw e;
		}
		
//		catch (IOException e) 
//		{
//			// TODO Auto-generated catch block
//			e.printStackTrace();
//		} 
//		catch (JAXBException e) 
//		{
//			// TODO Auto-generated catch block
//			e.printStackTrace();
//		} 
//		catch (ParserConfigurationException e) 
//		{
//			// TODO Auto-generated catch block
//			e.printStackTrace();
//		}
//		
//		return null;
	}
}

